package com.qmth.cqb.paper.service.impl;

import java.util.Date;
import java.util.List;

import main.java.com.UpYun;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.data.domain.Example;
import org.springframework.stereotype.Service;

import cn.com.qmth.examcloud.common.uac.entity.AccessUser;

import com.qmth.cqb.paper.dao.ExamFileRepo;
import com.qmth.cqb.paper.model.ExamFile;
import com.qmth.cqb.paper.service.ExamFileService;

/**
 * @author  	chenken
 * @date    	2017年7月13日 下午4:48:02
 * @company 	QMTH
 * @description ExamFileServiceImpl.java
 */
@Service("examFileService")
public class ExamFileServiceImpl implements ExamFileService{

	@Autowired
	private ExamFileRepo examFileRepo;
	
	@Value("${upyun.bucketName}")
	protected String bucketName;
	
	@Value("${upyun.userName}")
	protected String userName;
	
	@Value("${upyun.password}")
	protected String password;
	
	@Override
	public void saveExamFiles(List<ExamFile> examFileList,AccessUser accessUser){
		for(ExamFile examFile:examFileList){
			saveExamFile(examFile,accessUser);
		}
	}

	@Override
	public List<ExamFile> findExamFileListByExamFile(ExamFile examFile) {
		return examFileRepo.findAll(Example.of(examFile));
	}

	@Override
	public void saveExamFile(ExamFile examFile, AccessUser accessUser) {
		ExamFile oldExamFile = new ExamFile();
		oldExamFile.setExamId(examFile.getExamId());
		oldExamFile.setExamType(examFile.getExamType());
		oldExamFile.setCourseId(examFile.getCourseId());
		oldExamFile.setExamFileType(examFile.getExamFileType());
		oldExamFile = examFileRepo.findOne(Example.of(oldExamFile));
		if(oldExamFile!=null){
			//删除又拍云上的文件
			UpYun upyun = new UpYun(bucketName,userName,password);
			upyun.deleteFile(oldExamFile.getFilePath());
			//删除数据库记录
			examFileRepo.delete(oldExamFile);
		}
		examFile.setCreateTime(new Date());
		examFile.setCreateUser(accessUser.getName());
		examFileRepo.save(examFile);
	}

}

